
package de.ivu.elect.presentation.statistik;

import java.util.Date;

import javax.annotation.Nullable;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.statistik.entity.StatistikLauf;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.View;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.statistik.form.StatistikLaufViewFormBuilder;

/**
 *  on 30.01.2017.
 */
@OnlineHilfeId(value = "657")
@Named(AbstractStatistikLaufCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractStatistikLaufCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.STATISTIK_LAUF_CREATE)
public class StatistikLaufCreateView extends AbstractStatistikLaufCreateView {

  private static final long serialVersionUID = 1L;

  @Inject
  private StatistikLaufViewFormBuilder statistikLaufViewFormBuilder;

  public StatistikLaufCreateView() {
    super();
  }

  @Nullable
  @PreConditionCheck
  public String checkCondition() {
    if (!isWahlterminSelected() && !isWahlSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  public StatistikLauf getEntity() {
    StatistikLauf entity = super.getEntity();
    entity.setWahl(getSelectedWahl());
    entity.setWahltermin(getSelectedWahltermin());
    entity.setAusloeser(getSelectedBenutzerNameFormatted());
    entity.setZeitpunktDesLaufs(new Date());
    return entity;
  }

  @Override
  protected void addProperties(FormBuilder formBuilder, StatistikLauf entity) {
    statistikLaufViewFormBuilder.addProperties(formBuilder, entity);
  }
}
